/******************************************************************************************
	DEMO: Corrupt a database using a hex editor

	Useful Links:
		https://www.sqlskills.com/blogs/paul/creating-detaching-re-attaching-and-fixing-a-suspect-database/
*******************************************************************************************/

USE master;
GO

CREATE DATABASE hexed;

SELECT * FROM sys.master_files WHERE DB_NAME(database_id) = 'hexed';
--database_id	file_id	file_guid	type	type_desc	data_space_id	name	physical_name
--18	1	AC3F6F06-12FF-49EC-ACCD-B215AAF745C6	0	ROWS	1	hexed	C:\Program Files\Microsoft SQL Server\MSSQL13.QUASAR\MSSQL\DATA\hexed.mdf
--18	2	657D3B09-D18E-4CA1-9D52-0FA4A249540E	1	LOG	0	hexed_log	C:\Program Files\Microsoft SQL Server\MSSQL13.QUASAR\MSSQL\DATA\hexed_log.ldf

--Set DB offline
ALTER DATABASE hexed SET OFFLINE;

--Detach DB
EXEC sys.sp_detach_db 'hexed';

/*********************************************
	edit the database file in a hex editor
*********************************************/

--bring it back
CREATE DATABASE HEXED ON
	(FILENAME = 'C:\PROGRAM FILES\MICROSOFT SQL SERVER\MSSQL13.QUASAR\MSSQL\DATA\HEXED.MDF'),
	(FILENAME = 'C:\PROGRAM FILES\MICROSOFT SQL SERVER\MSSQL13.QUASAR\MSSQL\DATA\HEXED_LOG.LDF')
	FOR ATTACH;
----WHAT WILL HAPPEN?
--Check SQL Server Error Log
--Look for dumps

/*
CREATE DATABASE Hexed ON
	(FILENAME = 'C:\Program Files\Microsoft SQL Server\MSSQL13.MSSQLSERVER\MSSQL\DATA\hexed.mdf'),
	(FILENAME = 'C:\Program Files\Microsoft SQL Server\MSSQL13.MSSQLSERVER\MSSQL\DATA\hexed_log.ldf')
	FOR ATTACH;
*/

ALTER DATABASE hexed SET ONLINE; --nope

DROP DATABASE hexed; --DB does not exist since it was detached. Now we cannot get it back online without advanced trickery.
